
//	MacMud.h

#ifndef _MACMUD
#define _MACMUD

#define CREATOR			'MMud'
#define FTYPE_TEXT		'TEXT'

// The menubar resources
enum {
	MAINMENUBAR	= 128,

	M_APPLE					= 128,
		M_APPLE_ABOUT		= 1,
		M_APPLE_PREFERENCES = 2,
	M_FILE					= 129,
		M_FILE_NEW			= 1,
		M_FILE_QUIT			= 3,
	M_EDIT					= 130,
		M_EDIT_UNDO			= 1,
		M_EDIT_CUT			= 3,
		M_EDIT_COPY			= 4,
		M_EDIT_PASTE		= 5,
		M_EDIT_CLEAR		= 6,
		M_EDIT_SELECTALL	= 8,
	M_MISC					= 131,
		M_MISC_STARTUP		= 1,
		M_MISC_SHUTDOWN		= 2,
		M_MISC_SHOWMSG		= 4
};

enum {
	ALERT_YES		=	1,
	ALERT_NO		=	2,
	ALERT_CANCEL	=	3
};

extern Boolean			gRunning;
extern Boolean			gProgramDone;
extern THPrint			gPrintHdl;
extern short			gDefaultFont;
extern short			gDefaultSize;
extern short			gDefaultFace;
extern short			gDefaultJust;
extern Boolean			gCancelOp;
extern FSSpec			gLastFSSpec;

#define kSysEnvironsVersion 	1

#define kMinHeap				(1024 * 1024)	
#define kMinSpace				(512 * 1024)

#define kExtremeNeg		 		-32768
#define kExtremePos				32767 - 1
#define kExtremeLong			0x7fffffff

#define rUserAlert				128
#define sStdStrings				128
#define eStandardErr			1
#define eWrongMachine			2
#define eSmallSize				3
#define eNoXtc					4
#define eNoMemory				5
#define eNoPrinter				6
#define eFailedToStart			7

#define rSaveAlert				129
#define rMsgAlert				130
#define rShutdownAlert			133

#define kDebugView				128
#define kConsoleView			129

#define kAboutView 				500		// View id for about box
#define kSplashView				501		// View id for splash screen

void _DataInit();						// Standard routine

void AlertUser(short error, short message);
pascal void FatalError(short error, short message);
void AlertMsg(ConstStr255Param theMsg, ConstStr255Param theParam);

Boolean DoStandardGetFile(SFTypeList typeList, short numTypes);
Boolean DoStandardPutFile(ConstStr255Param prompt, ConstStr255Param defaultName);

Boolean RunMudlib(void);

void DoCloseAllWindows(void);

pascal Boolean XtcMain(UI_ViewPtr view, UI_Action *action);
pascal Boolean XtcAboutBox(UI_ViewPtr view, UI_Action *action);
pascal Boolean XtcSplashScreen(UI_ViewPtr view, UI_Action *action);

pascal Boolean XtcDebug(UI_ViewPtr view, UI_Action *action);
pascal Boolean XtcConsole(UI_ViewPtr view, UI_Action *action);

extern pascal Boolean XtcDebug(UI_ViewPtr view, UI_Action *action);

#endif