#include "systypes.r"
#include "types.r"

#include "config.h"
#include "patchlevel.h"
#include "lpconsole.h"

#undef __kPrefSize
#define __kPrefSize			2048	/* Default max app size */
#undef __kMinSize
#define __kMinSize			1024	/* Default min app size */

#ifndef __kWindowTitle
#ifdef COMPAT_MODE
#define __kWindowTitle		"MacMud " GAME_VERSION STR_PATCH_LEVEL " (Compatible)"
#else
#define __kWindowTitle		"MacMud " GAME_VERSION STR_PATCH_LEVEL " (Full)"
#endif
#endif

#ifndef CREATOR
	#define CREATOR 'MMud'
#endif

#ifndef FCREATOR
	#define FCREATOR 'MPS '
#endif

/* here is the quintessential MultiFinder friendliness device, the SIZE resource */

resource 'SIZE' (-1) {
	dontSaveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,
	multiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreChildDiedEvents,
	is32BitCompatible,
	isHighLevelEventAware,
	localAndRemoteHLEvents,
	notStationeryAware,
	dontUseTextEditServices,
	reserved,
	reserved,
	reserved,
	kPrefSize * 1024,
	kMinSize * 1024	
};

type CREATOR as 'STR ';

resource CREATOR (0) {
	"MacMud 3.2\n"
	"Copyright 1992-93 by Mimir Reynisson.\n"
	"All Rights Reserved."
};

resource 'BNDL' (128) {
	'MMud',
	0,
	{
		'ICN#',
		{
			0, 128
		},
		'FREF',
		{
			0, 128
		}
	}
};

resource 'FREF' (128) {
	'APPL',
	0,
	""
};

data 'ICN#' (128) {
	$"0000 0E00 0000 7E00 0000 7A00 0001 C200"            /* ......~...z.... */
	$"0007 C200 0000 0200 0600 3760 0900 2DE0"            /* .........7`.-. */
	$"1F80 22A0 1080 2560 1080 2AA0 1080 1FC0"            /* .".%`.*.. */
	$"0F00 1040 0900 10C0 0902 B070 0B55 55D8"            /* ...@...p.UU */
	$"0EA8 156C 0C00 D0DC 0D56 D06C 0D56 10DC"            /* ..l...VlV.. */
	$"0C00 106C 0C00 10DC 0C00 146C 0C00 1EDC"            /* ...l.......l.... */
	$"0C00 7E6C 0C3F FFFE 1FFF FFFF 7FFF FFFF"            /* ..~l.?.......... */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
};

data 'icl8' (128) {
	$"2A2A 2A2A 2A2A 2A2A 2A2A 2A2A 2A2A 2A2A"            /* **************** */
	$"2A2A 2A2A 6969 FE2A 2A2A 2A2A 2A2A 2A2A"            /* ****ii.********* */
	$"2A2A 2A2A 2A2A 2A2A 2A2A 2A2A 2A2A 2A2A"            /* **************** */
	$"2A69 6969 6969 FE2A 2A2A 2A2A 2A2A 2A2A"            /* *iiiii.********* */
	$"2A2A 2A2A 2A2A 2A2A 2A2A 2A2A 2A2A 2A2A"            /* **************** */
	$"2A69 6969 692A FE2A 2A2A 2A2A 2A2A 2A2A"            /* *iiii*.********* */
	$"2A2A 2A2A 2A2A 2A2A 2A2A 2A2A 2A2A 2A69"            /* ***************i */
	$"6969 2A2A 2A2A FE2A 2A2A 2A2A 2A2A 2A2A"            /* ii****.********* */
	$"2A2A 2A2A 2A2A 2A2A 2A2A 2A2A 2A69 6969"            /* *************iii */
	$"6969 2A2A 2A2A FE2A 2A2A 2A2A 2A2A 2A2A"            /* ii****.********* */
	$"2A2A 2A2A 2A2A 2A2A 2A2A 2A2A 2A2A 2A2A"            /* **************** */
	$"2A2A 2A2A 2A2A FE2A 2A2A 2A2A 2A2A 2A2A"            /* ******.********* */
	$"2A2A 2A2A 2AFC FC2A 2A2A 2A2A 2A2A 2A2A"            /* *****..********* */
	$"2A2A FCFC 2AFC FCFC 2AFC FC2A 2A2A 2A2A"            /* **..*...*..***** */
	$"2A2A 2A2A FCF7 F8FC 2A2A 2A2A 2A2A 2A2A"            /* ****....******** */
	$"2A2A FCF7 FCFC F8FC FCFB FC2A 2A2A 2A2A"            /* **.........***** */
	$"2A2A 2AFC FCFC FCFC FC2A 2A2A 2A2A 2A2A"            /* ***......******* */
	$"2A2A FCF7 F7F8 FBF8 FBF8 FC2A 2A2A 2A2A"            /* **.........***** */
	$"2A2A 2AFC F7F7 F8F7 FC2A 2A2A 2A2A 2A2A"            /* ***......******* */
	$"2A2A FCF7 F7FB F8FB F8FB FC2A 2A2A 2A2A"            /* **.........***** */
	$"2A2A 2AFC F7F8 F7F8 FC2A 2A2A 2A2A 2A2A"            /* ***......******* */
	$"2A2A FCF7 FCF8 FCF8 FCF8 FC2A 2A2A 2A2A"            /* **.........***** */
	$"2A2A 2AFC F7F7 F8F7 FC2A 2A2A 2A2A 2A2A"            /* ***......******* */
	$"2A2A 2AFC FCFC FCFC FCFC 2A2A 2A2A 2A2A"            /* ***.......****** */
	$"2A2A 2A2A FCFC FCFC 2A2A 2A2A 2A2A 2A2A"            /* ****....******** */
	$"2A2A 2AFC F7F8 2BF8 2BFC 2A2A 2A2A 2A2A"            /* ***...+.+.****** */
	$"2A2A 2A2A FCF7 F8FC 2A2A 2A2A 2A2A 2A2A"            /* ****....******** */
	$"2A2A 2AFC F72B F82B FCFC 2A2A 2A2A 2A2A"            /* ***..+.+..****** */
	$"2AF5 2AF5 FCF7 F7FC 2AF5 2AF5 2AF5 FC2A"            /* *.*.....*.*.*..* */
	$"FC2A FCFC F7F8 2BF8 2BFC FCFC 2AF5 2AF5"            /* .*....+.+...*.*. */
	$"F52A F52A FCF7 FCFC 2AFC 2AFC 2AFC F8FC"            /* .*.*....*.*.*... */
	$"F8FC F8FC F7FE F8FE FCFC F8FC FC2A F52A"            /* .............*.* */
	$"2AF5 2AF5 FCFC FCF7 FCF8 FCF8 FCF8 2BF8"            /* *.*...........+. */
	$"2BF8 2BFC F7FE 2BFE F7FC FBF8 FCFC 2AF5"            /* +.+...+.......*. */
	$"F52A F52A FCFC F7F7 F82B F82B F82B F82B"            /* .*.*.....+.+.+.+ */
	$"FEFE F8FC F72B F82B FCFC F8FC FCFC F52A"            /* .....+.+.......* */
	$"2AF5 2AF5 FCFC F7FE 2BFE 2BFE 2BFE FEF8"            /* *.*.....+.+.+... */
	$"FEFE 2BFC F7F8 2BF8 2BFC FBF8 FCFC 2AF5"            /* ..+...+.+.....*. */
	$"F52A F52A FCFC F7FE F8FE F8FE F8FE FE2B"            /* .*.*...........+ */
	$"F82B F8FC F72B F82B FCFC F8FC FCFC F52A"            /* .+...+.+.......* */
	$"2AF5 2AF5 FCFC F7F7 2BF8 2BF8 2BF8 2BF8"            /* *.*.....+.+.+.+. */
	$"2BF8 2BFC F7F8 2BF8 2BFC FBF8 FCFC 2AF5"            /* +.+...+.+.....*. */
	$"F52A F52A FCFC F7F7 F82B F82B F82B F82B"            /* .*.*.....+.+.+.+ */
	$"F82B F8FC F72B F82B FCFC F8FC FCFC F52A"            /* .+...+.+.......* */
	$"2AF5 2AF5 FCFC F7F7 2BF8 2BF8 2BF8 2BF8"            /* *.*.....+.+.+.+. */
	$"2BF8 2BFC F7FE 2BF8 2BFC FBF8 FCFC 2AF5"            /* +.+...+.+.....*. */
	$"F52A F52A FCFC F7F7 F82B F82B F82B F82B"            /* .*.*.....+.+.+.+ */
	$"F82B F8FC FEFE FE2B FCFC F8FC FCFC F52A"            /* .+.....+.......* */
	$"2AF5 2AF5 FCFC F7F7 2BF8 2BF8 2BF8 2BF8"            /* *.*.....+.+.+.+. */
	$"2BA5 A5A5 A5FE FEF8 2BFC FBF8 FCFC 2AF5"            /* +...+.....*. */
	$"F52A F52A FCFC F7F7 F82B A5A5 A5A5 A5A5"            /* .*.*.....+ */
	$"A5A5 A59F A5A5 A5A5 A5A5 A5A5 A5A5 A52A"            /* * */
	$"2AF5 2AA5 A5A5 A5A5 A5A5 A5A5 A5A5 9FA5"            /* *.* */
	$"9FA5 9FA5 9FA5 9FA5 9FA5 9FA5 9FA5 9FA5"            /*  */
	$"F5A5 A59F A59F A59F A59F A59F A5A5 A59F"            /* . */
	$"A59F A59F A59F A59F A5A5 A59F A5A5 A59F"            /*  */
	$"A5A5 A5A5 A5A5 9FFC A5A5 9FA5 9FA5 9FA5"            /* . */
	$"A5A5 9FA5 9FA5 9FFC 9FA5 A5A5 A5FC A5A5"            /* .. */
	$"A59F A59F FC9F FCA5 FCA5 FCA5 FCA5 FCA5"            /* ...... */
	$"FC9F FCA5 FC9F A5A5 FCA5 FCA5 FCA5 FCA5"            /* ....... */
	$"9FFC A5FC A5FC A5FC A5FC A5FC A5FC A5FC"            /* ........ */
	$"A5FC A5FC A5FC A5FC A5FC A5FC A5FC A5A5"            /* ....... */
	$"FCA5 FCA5 FCA5 FCA5 FCA5 FCA5 FCA5 FCA5"            /* ........ */
	$"FCA5 FCA5 FCA5 FCA5 FCA5 FCA5 FCA5 FCA5"            /* ........ */
};

data 'icl4' (128) {
	$"CCCC CCCC CCCC CCCC CCCC 44FC CCCC CCCC"            /* D. */
	$"CCCC CCCC CCCC CCCC C444 44FC CCCC CCCC"            /* DD. */
	$"CCCC CCCC CCCC CCCC C444 4CFC CCCC CCCC"            /* DL. */
	$"CCCC CCCC CCCC CCC4 44CC CCFC CCCC CCCC"            /* D. */
	$"CCCC CCCC CCCC C444 44CC CCFC CCCC CCCC"            /* DD. */
	$"CCCC CCCC CCCC CCCC CCCC CCFC CCCC CCCC"            /* . */
	$"CCCC CEEC CCCC CCCC CCEE CEEE CEEC CCCC"            /* .... */
	$"CCCC ECCE CCCC CCCC CCEC EECE EEEC CCCC"            /* ..... */
	$"CCCE EEEE ECCC CCCC CCEC CCEC ECEC CCCC"            /* ....... */
	$"CCCE CCCC ECCC CCCC CCEC CECE CEEC CCCC"            /* ... */
	$"CCCE CCCC ECCC CCCC CCEC ECEC ECEC CCCC"            /* ...... */
	$"CCCE CCCC ECCC CCCC CCCE EEEE EECC CCCC"            /* .... */
	$"CCCC EEEE CCCC CCCC CCCE CCCC CECC CCCC"            /* .. */
	$"CCCC ECCE CCCC CCCC CCCE CCCC EECC CCCC"            /* .. */
	$"C0C0 ECCE C0C0 C0EC ECEE CCCC CEEE C0C0"            /* ..... */
	$"0C0C ECEE CECE CECE CECE CFCF EECE EC0C"            /* ....... */
	$"C0C0 EEEC ECEC ECCC CCCE CFCF CEEC EEC0"            /* ....... */
	$"0C0C EECC CCCC CCCC FFCE CCCC EECE EE0C"            /* ....... */
	$"C0C0 EECF CFCF CFFC FFCE CCCC CEEC EEC0"            /* ..... */
	$"0C0C EECF CFCF CFFC CCCE CCCC EECE EE0C"            /* ....... */
	$"C0C0 EECC CCCC CCCC CCCE CCCC CEEC EEC0"            /* ... */
	$"0C0C EECC CCCC CCCC CCCE CCCC EECE EE0C"            /* ...... */
	$"C0C0 EECC CCCC CCCC CCCE CFCC CEEC EEC0"            /* ... */
	$"0C0C EECC CCCC CCCC CCCE FFFC EECE EE0C"            /* ........ */
	$"C0C0 EECC CCCC CCCC CEEE EFFC CEEC EEC0"            /* ...... */
	$"0C0C EECC CCEE EEEE EEED EEEE EEEE EEEC"            /* .............. */
	$"C0CE EEEE EEEE EEDE DEDE DEDE DEDE DEDE"            /* .............. */
	$"0EED EDED EDED EEED EDED EDED EEED EEED"            /* ................ */
	$"EEEE EEDE EEDE DEDE EEDE DEDE DEEE EEEE"            /* ................ */
	$"EDED EDEE EEEE EEEE EDEE EDEE EEEE EEEE"            /* ................ */
	$"DEEE EEEE EEEE EEEE EEEE EEEE EEEE EEEE"            /* ................ */
	$"EEEE EEEE EEEE EEEE EEEE EEEE EEEE EEEE"            /* ................ */
};

data 'ics#' (128) {
	$"00F0 01F0 0390 307C 787C 487C 3048 3FFE"            /* .....0|x|H|0H?. */
	$"3EFE 3FCE 204E 207E 20FE 7FFF FFFF FFFF"            /* >.? N ~ ....... */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
};

data 'ics8' (128) {
	$"2A2A 2A2A 2A2A 2A2A 6969 69FE 2A2A 2A2A"            /* ********iii.**** */
	$"2A2A 2A2A 2A2A 2A69 6969 69FE 2A2A 2A2A"            /* *******iiii.**** */
	$"2A2A 2A2A 2A2A 6969 692A 2AFE 2A2A 2A2A"            /* ******iii**.**** */
	$"2A2A FCFC 2A2A 2A2A 2AFC FCFC FCFC 2A2A"            /* **..*****.....** */
	$"2AFC FCFC FC2A 2A2A 2AFC FBFB FBFC 2A2A"            /* *....****.....** */
	$"2AFC F8F8 FC2A 2A2A 2AFC FCFC FCFC 2A2A"            /* *....****.....** */
	$"2A2A FCFC 2A2A 2A2A 2AFC F8F8 FC2A 2A2A"            /* **..*****....*** */
	$"F5F5 FCFC FCFC FCFC FCFC FEFE FCFC FCF5"            /* ................ */
	$"F5F5 FCFC FCFC FCF8 FEFC FEFE FCFC FCF5"            /* ................ */
	$"F5F5 FCFE FEFE FEFE FEFC F8F8 FCFC FCF5"            /* ................ */
	$"F5F5 FCF7 F8F8 F8F8 F8FC F8F8 FCFC FCF5"            /* ................ */
	$"F5F5 FCF7 F8F8 F8F8 F8FC FEFE FCFC FCF5"            /* ................ */
	$"F5F5 FCF7 F8F8 F8F8 A5A5 FEFE FCFB FCF5"            /* .............. */
	$"F5A5 A5A5 A5A5 A5A5 A5A5 A5A5 A5A5 A5A5"            /* . */
	$"A5A5 FCFC FCFC FCFC FCFC FCFC FCFC FCFC"            /* .............. */
	$"FCFC FCFC FCFC FCFC FCFC FCFC FCFC FCFC"            /* ................ */
};

data 'ics4' (128) {
	$"CCCC CCCC 444F CCCC CCCC CCC4 444F CCCC"            /* DODO */
	$"CCCC CC44 4CCF CCCC CCEE CCCC CEEE EECC"            /* DL... */
	$"CEEE ECCC CEEE EECC CECC ECCC CEEE EECC"            /* ....... */
	$"CCEE CCCC CECC ECCC 00EE EEEE EEFF EEE0"            /* .......... */
	$"00EE EEEC FEFF EEE0 00EF FFFF FECC EEE0"            /* ............... */
	$"00EC CCCC CECC EEE0 00EC CCCC CEFF EEE0"            /* ......... */
	$"00EC CCCC EEFF EEE0 0EEE EEEE EEEE EEEE"            /* .............. */
	$"EEEE EEEE EEEE EEEE EEEE EEEE EEEE EEEE"            /* ................ */
};
