
/*
 * Define this if you want the MUDWHO-service. You have to configure it
 * in mudwho.h.
 */
#undef MUDWHO

/*
 * Define this if you want to use the improved access restriction system.
 * Look at the file ACCESS.ALLOW for information. It replaces the old
 * ACCESS.DENY.
 */
#undef ACCESS_RESTRICTED

/* Version of the game in the form xx.xx.xx (leading zeroes) gc.
 * Two digits will be appended, that is the patch level.
 */
#define GAME_VERSION "03.01."

/*
 * How to extract an unsigned char from a char *.
 * If your compiler has the type 'unsigned char', then the cast-version
 * is best. If you do not know, use the simple version, and the game will
 * immediately terminate with a message if bad.
#define EXTRACT_UCHAR(p) (*p < 0 ? *p + 0x100 : *p)
 */
#define EXTRACT_UCHAR(p) (*(unsigned char *)p)

/*
 * What is the value of the first constant defined by yacc ? If you do not
 * know, compile, and look at y.tab.h.
 */
#define F_OFFSET		257

/*
 * Does the system have a getrusage call?
 */
#undef RUSAGE

/*
 * Do we spend some extra memory to increase the speed of call_other() ?
 *
 * If this is used then two bytes extra is reserved for each call_other()
 * in the stack code. These bytes will hold the function index for the 
 * last call made.
 *
 */
#define CACHE_CALL_OTHER 

/*
 * If you want to put wizards in groups and give each group a subdirectory
 * you should define this. Domain directorys must start witha capital
 * letter, and wizards names must not.
 */
#define DOMAINS

/*
 * Undef this if your system doesn't support Berkley type symlinks.
 */
#define SYMLINKS
 
/*
 * Define what ioctl to use against tty's.
 */

#undef USE_TIOCGETP	/* BSD */
#define USE_TCGETA 	/* SYSV */


/*
 * Some LPmuds on sun4 and sparcstations have had problems with the
 * call of inet_ntoa() in comm1.c.
 * If the game crash in query_ip_number() wen using inet_ntoa(),
 * then undefine the following symbol.
 * The query_ip_number() is called when doing the 'people' command
 * for example.
 */
#define INET_NTOA_OK 1

/*
 * Define LOG_SHOUT if you want all shouts to be logged in
 * mudlib/log/SHOUTS.
 */
#undef LOG_SHOUT

/*
 * When uploading files, we want fast response; however, normal players
 * shouldn't be able to hog the system in this way.  Define ALLOWED_ED_CMDS
 * to be the ratio of the no of ed cmds executed per player cmd, and
 * MAX_CMDS_PER_BEAT to be the bax no of buffered player commands the
 * system will accept in each heartbeat interval.
 */

#define	ALLOWED_ED_CMDS		20
#define	MAX_CMDS_PER_BEAT	5 /* not implemented yet :-( */

/*
 * Define SYSV if you are running system V with a lower release level than
 * Sys V.4.
 */

#define SYSV

/*
 * Define FCHMOD_MISSING only if your system doesn't have fchmod().
 */

#define FCHMOD_MISSING

/*
 * Define COMPAT_MODE if you are using mudlib 2.4.6 or older. This
 * replaces the old command line option -o.
 */

#define COMPAT_MODE

#define NO_IP_DEMON

/*
 * Use the NLHack patches made to the 2.4.5 driver
 */

#undef NLHACK

/*
 * Define this if you don't have (or want) sockets.
 */
#undef NOCOMM

/*
 * These have been transferred to the startup file
 */   

#define MUDHOSTNAME				(configs[0].u.cf_str)
#define MASTER_OBJECT			(configs[1].u.cf_str)
#define SIMUL_EFUN				(configs[2].u.cf_str)
#define INIT_FILE				(configs[3].u.cf_str)
#define SWAP_FILE				(configs[4].u.cf_str)
#define FORCE_INCLUDE			(configs[5].u.cf_str)
#define MUD_LIB					(configs[6].u.cf_str)
#define PLAYER_DIR				(configs[7].u.cf_str)
#define DOMAIN_DIR				(configs[8].u.cf_str)
#define DEFAULT_CASTLE			(configs[9].u.cf_str)
#define DEFAULT_WORKROOM		(configs[10].u.cf_str)
#define LOG_ADMIN_FILES			(configs[11].u.cf_str)
#define MAX_LOCAL_LOG_SIZE		(configs[12].u.cf_int)
#define MAX_GLOBAL_LOG_SIZE		(configs[13].u.cf_int)
#define READ_FILE_MAX_SIZE		(configs[14].u.cf_int)
#define TIME_TO_CLEAN_UP		(configs[15].u.cf_int)
#define TIME_TO_SWAP			(configs[16].u.cf_int)
#define TIME_TO_RESET			(configs[17].u.cf_int)
#define EVALUATOR_STACK_SIZE	(configs[18].u.cf_int)
#define COMPILER_STACK_SIZE		(configs[19].u.cf_int)
#define MAX_BITS				(configs[20].u.cf_int)
#define LIVING_HASH_SIZE		(configs[21].u.cf_int)
#define PORTNO					(configs[22].u.cf_int)
#define MAX_LOCAL				(configs[23].u.cf_int)
#define MAX_COST				(configs[24].u.cf_int)
#define MAX_ARRAY_SIZE			(configs[25].u.cf_int)
#define MAX_PLAYERS				(configs[26].u.cf_int)
#define	HTABLE_SIZE				(configs[27].u.cf_int)
#define OTABLE_SIZE				(configs[28].u.cf_int)
#define MAX_BYTE_TRANSFER 		(configs[29].u.cf_int)
#define MAX_STRING_LENGTH		(configs[30].u.cf_int)
#define RESERVED_SIZE			(configs[31].u.cf_int)
#define MAX_TRACE				(configs[32].u.cf_int)
#define DEBUG_LEVEL				(configs[33].u.cf_int)
#define TRACE_LEVEL				(configs[34].u.cf_int)
#define COMP_TRACE				(configs[35].u.cf_int)
#define AUTO_RESTART			(configs[36].u.cf_int)
#define RUNTIME_MEMORY			(configs[37].u.cf_int)
#define MULTI_CONNECTION		(configs[38].u.cf_int)
#define WHAT_MESSAGE			(configs[39].u.cf_int)

#define fopen(a,b) macfopen(a,b)
#define open(a,b) macopen(a,b)

#define check_string_lengths(l1, l2) \
    if (((l1) + (l2)) > MAX_STRING_LENGTH) error("String too large.\n");

/************************************************************************/
/*	END OF CONFIG -- DO NOT ALTER ANYTHING BELOW THIS LINE		*/
/************************************************************************/

/*
 * some generic large primes used by various hash functions in different files
 * You can alter these if you know of a better set of numbers!  Be sure
 * they are primes...
 */

#define	P1		701	/* 3 large, different primes */
#define	P2		14009	/* There's a file of them here somewhere :-) */
#define	P3		54001
