/*
 * Defines for nlhack-specific things
 */

/*
 * Max. lines for explode_file()
 */
#define MAX_EXPLODE_FILE_LINES 500

/*
 * Do we log writes in /open ?
 */
#define LOG_OPEN

/*
 * Max lines for output
 */
#define MAX_LINES 50

/*
 * Some defines for system-differences
 */

#ifndef S_ISDIR
#define S_ISDIR(m) (((m)&S_IFMT) == S_IFDIR)
#endif

/*
 * Define this if your readdir() returns a 'struct dirent' on your
 * system, in stead of the (older) 'struct direct'.
 */
#undef DIRENT

/* 
 * Define this if your system does not have strftime()
 */
#define NOSTRFTIME

/*
 * maximum size of grep'ed files
 */
#define GREP_FILE_SIZE 25000

/*
 * maximum number of files to be grep'ed at once 
 */
#define MAX_GREP_SIZE 10

/*
 * temporary grep-file. Choose it outside the mudlib.
 */
#define GREP_FILE "/tmp/grep_temp"

/*
 * Level of arches/gods
 */

#define ARCH_LEVEL 24

#define GOD_LEVEL 1000

/*
 * Prototypes
 */

int nlhack PROT((int, char *, struct svalue *, struct svalue *, int));
int visible PROT((struct object *));
void set_eff_user PROT((struct object *));
struct vector *all_inventory PROT((struct object *));
struct vector *users PROT((void));
void init_nlhack PROT((void));
void log_sbrk PROT((unsigned));
int log_admin_check PROT((char *));
int remove_file PROT((char *));
int all_cap PROT((char *));
